<?php

/**
 * Базовый Класс для плагина 
 */
class VKPOSTERBASE {

    const NAME_PLUGIN = 'VK Poster Group';
    const PATCH_PLUGIN = 'vk-poster-group'; //Директория плагина
    const URL_ADMIN_MENU_PLUGIN = 'vkposter-page'; //Адрес в админке
    const OPTIONS_NAME_PAGE = 'vkp-opt.php'; //страница опций плагина
    const NAME_TITLE_PLUGIN_PAGE = 'VK Poster Group'; // Название титульной страницы плагина
    const NAME_MENU_OPTIONS_PAGE = 'VKPosterGP'; // Название пунтка меню
    const NAME_SERVIC_ORIGINAL_TEXT = 'VK Poster Group plugin';
    const URL_PLUGIN_CONTROL = 'options-general.php?page=vkposter-page'; //Адрес админки плагина полный
    const URL_VK_DEVCREATE = 'https://vk.com/editapp?act=create'; //ССылка на создание придложения

    /**
     * Констурктора класса
     */

    public function __construct() {
        $this->addActios();
        $this->addOptions();
    }

    /**
     * Опции вызываемые деактивацией
     */
    public function deactivationPlugin() {
        delete_option('vkposter_id'); //ID группы или пользователя
        delete_option('vkposter_friends_only'); //Доступность записи, 0 - всем
        delete_option('vkposter_from_group'); //От чьего имени публиковать
        delete_option('vkposter_signed');
        delete_option('vkposter_counttext');
        delete_option('vkposter_onoff');
        delete_option('vkposter_jornal');
        delete_option('vkposter_idsoft'); //ID приложения
        delete_option('vkposter_token'); //Токен приложения
        delete_option('vkposter_userid'); //ID пользователя, создателя группы
        delete_option('vkposter_posttype'); //Типы выбранных записей
        delete_option('vkposter_proxy'); //Прокси
        delete_option('vkposter_proxy_userpaswd'); //Прокси юзер и пароль
    }

    /**
     * Активация фишек
     */
    public function addActios() {
        add_action('admin_menu', array($this, 'adminOptions'));
        // add_action('wp_enqueue_scripts', array($this, 'syleScriptHomepage')); //стили на фронтэнде
        add_filter('plugin_action_links', array($this, 'pluginLinkSetting'), 10, 2); //Настройка на странице плагинов
        //add_action('admin_init', array($this, 'provNonce'));
        add_action('add_meta_boxes', array($this, 'settingMetabos')); //Добавляем метабокс в пост
//        add_action('save_post', array($this, 'metaboxSavePost')); //Сохранение галки в постах
//        add_action('publish_post', array($this, 'metaboxSavePost')); //Сохранение галки в постах
//        add_action('publish_page', array($this, 'metaboxSavePost')); //Сохранение галки в постах
//        add_action('publish_post', array($this, 'metaboxSentVK')); //Отправка значений На стену ВК
//        add_action('publish_page', array($this, 'metaboxSentVK')); //Отправка значений На стену ВК
        $array_posts = get_option('vkposter_posttype'); //Типы постов
        foreach ($array_posts as $k => $v) { 
            add_action('save_' . $v, array($this, 'metaboxSavePost'), 9); //Сохранение галки в постах
            add_action('publish_' . $v, array($this, 'metaboxSavePost'), 9); //Сохранение галки в постах
            add_action('publish_' . $v, array($this, 'metaboxSentVK'), 11); //Отправка значений На стену ВК
        }
    }

    /**
     * Добавление опций в базу данных
     */
    public function addOptions() {
        add_option('vkposter_id', '-'); //ID группы или пользователя
        add_option('vkposter_friends_only', '0'); //Доступность записи, 0 - всем
        add_option('vkposter_from_group', '1'); //От чьего имени публиковать
        add_option('vkposter_signed','1');
        add_option('vkposter_counttext', '40');
        add_option('vkposter_onoff');
        add_option('vkposter_jornal', array());
        add_option('vkposter_idsoft'); //ID приложения
        add_option('vkposter_token'); //Токен приложения
        add_option('vkposter_userid'); //ID пользователя, создателя группы
        add_option('vkposter_posttype', array('post' => 'post')); //Типы выбранных записей
        add_option('vkposter_proxy'); //Прокси
        add_option('vkposter_proxy_user'); //Прокси юзер
        add_option('vkposter_proxy_userpaswd');  //Прокси юзер и пароль
    }

    /**
     * Параметры активируемого меню
     */
    public function adminOptions() {
        $page_option = add_options_page(self::NAME_TITLE_PLUGIN_PAGE, self::NAME_MENU_OPTIONS_PAGE, 8, self::URL_ADMIN_MENU_PLUGIN, array($this, 'showSettingPage'));
        add_action('admin_print_styles-' . $page_option, array($this, 'syleScriptAddpage')); //загружаем стили только для страницы плагина
    }

    /**
     * Добавляет пункт настроек на странице активированных плагинов
     */
    public function pluginLinkSetting($links, $file) {
        $this_plugin = self::PATCH_PLUGIN . '/index-vkp.php';
        if ($file == $this_plugin) {
            $settings_link1 = '<a href="options-general.php?page=vkposter-page">' . __("Settings", "default") . '</a>';
            array_unshift($links, $settings_link1);
        }
        return $links;
    }

    /**
     * Стили, скрипты Админка
     */
    public function syleScriptAddpage() {
        wp_register_script('vkposter_bootstrapjs1', plugins_url() . '/' . self::PATCH_PLUGIN . '/' . 'bootstrap/js/bootstrap.js');
        wp_enqueue_script('vkposter_bootstrapjs1');
        wp_register_script('vkposter_lightbox', plugins_url() . '/' . self::PATCH_PLUGIN . '/' . 'lib/lightbox/ekko-lightbox.min.js');
        wp_enqueue_script('vkposter_lightbox');
        wp_register_style('vkposter_bootstrapcss1', plugins_url() . '/' . self::PATCH_PLUGIN . '/' . 'bootstrap/css/bootstrap.css');
        wp_enqueue_style('vkposter_bootstrapcss1');
        wp_register_style('vkposter_adminpagecss', plugins_url() . '/' . self::PATCH_PLUGIN . '/' . 'css/adminpag.css');
        wp_enqueue_style('vkposter_adminpagecss');
        wp_register_style('vkposter_lightboxcss', plugins_url() . '/' . self::PATCH_PLUGIN . '/' . 'lib/lightbox/ekko-lightbox.min.css');
        wp_enqueue_style('vkposter_lightboxcss');
    }

    /**
     * Страница меню
     */
    public function showSettingPage() {
        include_once WP_PLUGIN_DIR . '/' . self::PATCH_PLUGIN . '/' . self::OPTIONS_NAME_PAGE;
    }

    /**
     * Метабокс в записи
     */
    public function settingMetabos() {
        $array_posts = get_option('vkposter_posttype'); //Типы постов
        foreach ($array_posts as $k => $v) { //Появляется только там где выбрал пользователь
            add_meta_box('vkposter-metabox', self::NAME_SERVIC_ORIGINAL_TEXT, array($this, 'metabosHtml'), "$v", 'side', 'high');
        }
    }

    /**
     * Отрисовка МетаБокса
     */
    public function metabosHtml($post) {
        $vkposter_onoff = get_option('vkposter_onoff');
        // Используем nonce для верификации
        wp_nonce_field(plugin_basename(__FILE__), 'vkposter_noncename');
        // Поля формы для введения данных
        if (empty($vkposter_onoff)) {
            if (get_post_meta($post->ID, '_vkposter_meta_value_key', true) == 'on') {
                $cheked = 'checked';
            } else {
                $cheked = '';
            }
        } elseif (!empty($vkposter_onoff)) {
            $cheked = 'checked';
        }
        echo '<input type="checkbox" name="vkposter_new_field" ' . $cheked . '/>';
        echo '<span class="description">Добавлять текст на стену VK при публикации?</span>';
        echo '<br><input type="radio" name="vkposter_new_field_radio" checked value="1">При публикации</>';
        echo '<br><input type="radio" name="vkposter_new_field_radio" value="2">При обновление</>';
    }

    /**
     * Сохранение данных Метабокса при сохрание записи
     */
    public function metaboxSavePost($post_id) {

        // проверяем nonce нашей страницы, потому что save_post может быть вызван с другого места.
        if (!wp_verify_nonce($_POST['vkposter_noncename'], plugin_basename(__FILE__))) {
            return $post_id;
        }

        // проверяем, если это автосохранение ничего не делаем с данными нашей формы.
        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
            return $post_id;
        }

        // проверяем разрешено ли пользователю указывать эти данные
        if (!current_user_can('edit_post', $post_id)) {
            return $post_id;
        }
        //Убедимся что поле установлено.
        //if (!isset($_POST['vkposter_new_field']))
        //    return;

        $data1 = $_POST['vkposter_new_field'];
        //Обновление данных в базе даннхы
        update_post_meta($post_id, '_vkposter_meta_value_key', $data1);
    }

    /**
     * Отправка данных На стену ВК при публикации записи
     */
    public function metaboxSentVK($post_id) {

        //$postId = intval($_REQUEST['postId']);
        $postData = get_post($post_id);
        $title = $postData->post_title;
        $text = $postData->post_content;
        $vkposter_onoff = get_option('vkposter_onoff');
        $vkpunk = new VKPOSTERFUNCTION;
        $status_post = $postData->post_status; //Статус поста
        $date_create = $postData->post_date_gmt; //Дата создания записи
        $date_modificed = $postData->post_modified_gmt; //Дата изменения записи
        $radio_chek = $_POST['vkposter_new_field_radio']; // получаем значение РадиоБутон

        if (!wp_verify_nonce($_POST['vkposter_noncename'], plugin_basename(__FILE__))) {

            //print_r($radio_chek);
            return $post_id;
        }

        // проверяем, если это автосохранение ничего не делаем с данными нашей формы.

        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {

            return $post_id;
        }

        // проверяем разрешено ли пользователю указывать эти данные
        if (!current_user_can('edit_post', $post_id)) {

            return $post_id;
        }

        if ($status_post == 'draft' OR $status_post == 'private' OR $status_post == 'trash') {

            return $post_id;
        }


        $chek = get_post_meta($post_id, '_vkposter_meta_value_key', true);

        if ($vkposter_onoff == 'on') {
            if ($date_create == $date_modificed) {
                $status_sent = $vkpunk->setVkWall($post_id, $text); //Отправка текста
                $vkpunk->logJornal($post_id, $title, $status_sent); //Логируем результаты
            } elseif ($date_create !== $date_modificed and $radio_chek !== '1') {
                $status_sent = $vkpunk->setVkWall($post_id, $text); //Отправка текста
                $vkpunk->logJornal($post_id, $title, $status_sent); //Логируем результаты
            }
        } elseif ($chek == 'on') {

            if ($date_create == $date_modificed) {
                $status_sent = $vkpunk->setVkWall($post_id, $text); //Отправка текста
                $vkpunk->logJornal($post_id, $title, $status_sent); //Логируем результаты
            } elseif ($date_create !== $date_modificed and $radio_chek !== '1') {
                $status_sent = $vkpunk->setVkWall($post_id, $text); //Отправка текста
                $vkpunk->logJornal($post_id, $title, $status_sent); //Логируем результаты
            }
        } else {
            return $post_id;
        }

        return;
    }

}
