<?php

/**
 * Класс с функционалом и обработками
 */
class VKPOSTERFUNCTION {

    const METHOD_URL_VK = 'https://api.vk.com/method/wall.post?'; //Метод постинга сообщений
    const METHOD_URL_VKIMAGE = 'https://api.vk.com/method/photos.getWallUploadServer?'; //Метод получения сервера загрузок изображения
    const METHOD_URL_VKIMAGE_SAVE = 'https://api.vk.com/method/photos.saveWallPhoto?'; //Загружает изображение в группу

    /**
     *
     * @var string Прокси сервер для CURL IP:порт
     */

    var $proxy;

    /**
     *
     * @var string Прокси сервер для CURL Пользователь:пароль
     */
    var $proxy_userpaswd;

    /**
     * Конструктор класса
     */
    public function __construct() {
        $this->proxy = get_option('vkposter_proxy');
        $this->proxy_userpaswd = get_option('vkposter_proxy_userpaswd');
    }

    /**
     * Условия для обновления версии плагина
     */
    public function IfElseUpdate() {
        $vkposter_posttype = get_option('vkposter_posttype'); //Типы постов
        if (empty($vkposter_posttype)) { //установка опции по умолчанию
            update_option('vkposter_posttype', array('post' => 'post'));
        }
    }

    /**
     * Создавалка записи на стене вконтакте
     */
    public function setVkWall($post_id, $string) {

        $postData = get_post($post_id);
        $title = $postData->post_title;
        $text = $postData->post_content;
        $link_post = $postData->guid; // ссылка на запись

        $vkposter_id = get_option('vkposter_id'); //ID группы или пользователя
        $vkposter_friends_only = get_option('vkposter_friends_only'); //Доступность записи, 0 - всем
        $vkposter_from_group = get_option('vkposter_from_group'); //От чьего имени публиковать
        $vkposter_signed = get_option('vkposter_signed');
        $vkposter_counttext = get_option('vkposter_counttext');
        $vkposter_userid = get_option('vkposter_userid'); //ID пользователя, создателя группы
        $vkposter_token = get_option('vkposter_token'); //Токен приложения
        if ($vkposter_counttext == 0) { //пост без ограничений
            $text_clear = wp_kses($title) . "\n\n " . wp_kses($string, 'strip').' ';
        } else { //Пост с обрезкой до кол-ва знаков указанных пользователем
            $text_clear = wp_kses($title) . "\n\n " . wp_trim_words(wp_kses($string, 'strip').' ', $vkposter_counttext, '...');
        }
        //$imgage = 'photo' . $vkposter_userid . '_' . $this->setImageVK($text)->id; //Получаем ID фотографии
        $imgage = $this->setImageVK($text)->id; //Получаем ID фотографии
        if (!empty($this->setImageVK($text)->id)) { //Миниатюра есть
            $argument = array(
                "owner_id" => $vkposter_id,
                "from_group" => $vkposter_from_group,
                "friends_only" => $vkposter_friends_only,
                "signed" => $vkposter_signed,
                "message" => $text_clear,
                "attachments" => $imgage . ',' . $link_post
            );
        }
        if (empty($this->setImageVK($text)->id)) { //Миниатюры нет
            $argument = array(
                "owner_id" => $vkposter_id,
                "from_group" => $vkposter_from_group,
                "friends_only" => $vkposter_friends_only,
                "signed" => $vkposter_signed,
                "message" => $text_clear . $link_post
            );
        }
        $result = $this->sentRequesVK(self::METHOD_URL_VK, $argument, $this->proxy);
        return $result;
    }

    /**
     * Запросы к сервису Вконтакте
     * @param strint $method Полный метод ВК, с УРЛ и знаком ?
     * @param array $arg Массив аргументов для создания запроса
     */
    public function sentRequesVK($method, $arg, $proxy = null) {
        $vkposter_token = get_option('vkposter_token'); //Токен приложения
        $arg['access_token'] = $vkposter_token;
        $query = http_build_query($arg);
        if (!empty($proxy)) { //Если прокси, то отправляем по старорму
            $url = $method . $query;
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_PROXY, $proxy);
            curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 12);
            if (!empty($this->proxy_userpaswd)) {
                curl_setopt($curl, CURLOPT_PROXYUSERPWD, $this->proxy_userpaswd);
            }
            $curlinfo = curl_exec($curl); //Результат запроса
            $response = curl_getinfo($curl); //Информация о запросе
            curl_close($curl);
            return $curlinfo;
        } else { //Если не прокси, шлём так
            $curlinfo = wp_remote_post($method, array('body' => $query));
            return $curlinfo['body'];
        }

    }

    /**
     * Проверка Чекеда
     * @param string $options Опция из базы данных
     * @param string $value Текущее значение для сравнения (например значение из цикла)
     * @return echo checked или пусто
     */
    public function chekedOptions($options, $value) {
        if (!empty($options) or ! empty($value)) {
            if ($options == $value) {
                echo 'checked';
            } elseif ($options !== $value) {
                echo '';
            }
        }
    }

    /**
     * Получение изображения поста из миниатюры или из прикрепленного изображения
     */
    public function setImageVK($text) {
        $vkposter_id = get_option('vkposter_id'); //ID группы или пользователя
        $images_post = get_attached_file(get_post_thumbnail_id());

        $vkposter_token = get_option('vkposter_token'); //Токен приложения
        if (empty($images_post)) {
            $media = get_attached_media('image');
            $image = array_shift($media);
            $images_post = get_attached_file($image->ID); //Изображение прикреплённое к посту
            if (empty($images_post)) {
                $images_post = $this->searchImgaeText($text); // Ищем изображение в тексте
                if (empty($images_post)) {
                    return false;
                }
            }
        }
        $argument = array(
            "group_id" => trim($vkposter_id, '-'),
            "version" => "5.27"
        );
        $curlinfo = $this->sentRequesVK(self::METHOD_URL_VKIMAGE, $argument, $this->proxy);
        unlink($argument);

        if (!empty($curlinfo)) {
            $UrlObj = json_decode($curlinfo);
            $urlimgvk = $UrlObj->response->upload_url;
        }
        if (!empty($urlimgvk)) {
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $urlimgvk);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, array('photo' => '@' . $images_post));
            if (!empty($this->proxy)) {
                curl_setopt($curl, CURLOPT_PROXY, $this->proxy);
                curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 12);
            }
            if (!empty($this->proxy_userpaswd)) {
                curl_setopt($curl, CURLOPT_PROXYUSERPWD, $this->proxy_userpaswd);
            }
            $curlinfo = curl_exec($curl); //Результат запроса
            $response = curl_getinfo($curl); //Информация о запросе
            curl_close($curl);
            $imageObject = json_decode($curlinfo);
            if (!empty($imageObject->server) && !empty($imageObject->photo) && !empty($imageObject->hash)) {

                $argument = array(
                    "group_id" => trim($vkposter_id, '-'),
                    "server" => $imageObject->server,
                    "photo" => $imageObject->photo,
                    "hash" => $imageObject->hash
                );
                $curlinfo = $this->sentRequesVK(self::METHOD_URL_VKIMAGE_SAVE, $argument, $this->proxy);
                unlink($argument);

                $resultObject = json_decode($curlinfo);

                if (isset($resultObject) && isset($resultObject->response[0]->id)) {
                    return $resultObject->response[0];
                } else {
                    return false;
                }
            }
        }
    }

    /**
     * Поиск изображений в тексте
     * @param string $text Текст поста с тегами HTML
     * @return string абсолютный серверный путь до изображения
     */
    public function searchImgaeText($text) {
        $first_img = '';
        ob_start();
        ob_end_clean();
        $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $text, $matches);
        $first_img = $matches [1] [0];
        $col1 = strlen(WP_CONTENT_URL);
        $col2 = strlen($first_img);
        $patch = substr($first_img, $col1, $col2);
        $result = WP_CONTENT_DIR . $patch;
// В перспективе изображение по умолчанию (сейчас не реализованно)
        if (empty($first_img)) {
            return false;
            //$first_img = "/images/default.jpg";
        }
        return $result;
    }

    /**
     * Функция логирования, для вкладки журнал
     */
    public function logJornal($idpost, $title, $status) {

        $vkposter_jornal_old = get_option('vkposter_jornal');
        if (count($vkposter_jornal_old) >= 50) {
            $vkposter_jornal_old = array_slice($vkposter_jornal_old, -40);
        }
        $time = current_time('mysql');
        $vkposter_jornal_temp = array('time' => $time, 'idpost' => $idpost, 'title' => $title, 'status' => $status);
        $vkposter_jornal_new = $vkposter_jornal_old;
        array_push($vkposter_jornal_new, $vkposter_jornal_temp);
        update_option('vkposter_jornal', $vkposter_jornal_new);
    }

    /**
     * Получает токен из УРЛ
     * @param string $stringurl Урл содержащий токен, или сам токен
     */
    public function getTokenUrl($stringurl) {

        $start = 'access_token=';
        $end = '&expires_in';
        if (stripos($stringurl, $start)) {
            $result = $this->cutTextStartEnd($stringurl, $start, $end);
        } else {
            $result = $stringurl;
        }

        return $result;
    }

    /**
     * Обрезка контента по условию начала и конца
     * @param string $text Текст который мы хотим обрезать
     * @param string $start Начало от куда нужно обрезать
     * @param string $end Конец до куда нужно резать
     */
    public function cutTextStartEnd($text, $start, $end) {
        $posStart = stripos($text, $start);
        if ($posStart === false)
            return FALSE;

        $text = substr($text, $posStart + strlen($start));
        $posEnd = stripos($text, $end);
        if ($posEnd === false)
            return FALSE;

        $result = substr($text, 0, 0 - (strlen($text) - $posEnd));
        return $result;
    }

}
